local Sackville = LibStub("AceAddon-3.0"):GetAddon("Sackville")
local B = LibStub("LibBabble-Inventory-3.0")
local BL = B:GetLookupTable()

Sackville.Options = {}

Sackville.Options.categories = {
    [BL["Armor"]] = {
        [1] = {
            negate = false,
            operation = "and",
            category = "Equipment",
            subCategory = BL["Armor"]
        }
    },
    [BL["Consumable"]] = {
        [1] = {
            negate = false,
            operation = "and",
            category = "Consumable"
        }
    },
    [BL["Weapon"]] = {
        [1] = {
            negate = false,
            operation = "and",
            category = BL["Weapon"]
        }
    },
    [BL["Trinket"]] = {
        [1] = {
            negate = false,
            operation = "and",
            category = "Equipment",
            subCategory = BL["Trinket"]
        }
    },
    ["Jewelry"] = {
        [1] = {
            negate = false,
            operation = "or",
            category = "Equipment",
            subCategory = BL["Ring"]
        },
        [2] = {
            negate = false,
            operation = "and",
            category = "Equipment",
            subCategory = BL["Neck"]
        }
    },
    [BL["Tabard"]] = {
        [1] = {
            negate = false,
            operation = "and",
            category = "Equipment",
            subCategory = BL["Tabard"]
        }
    },
    [BL["Food & Drink"]] = {
        [1] = {
            negate = false,
            operation = "and",
            category = BL["Consumable"],
            subCategory = BL["Food & Drink"]
        }
    },
    [BL["Potion"]] = {
        [1] = {
            negate = false,
            operation = "and",
            category = BL["Consumable"],
            subCategory = BL["Potion"]
        }
    },
    [BL["Elixir"]] = {
        [1] = {
            negate = false,
            operation = "and",
            category = BL["Consumable"],
            subCategory = BL["Elixir"]
        }
    },
    [BL["Flask"]] = {
        [1] = {
            negate = false,
            operation = "and",
            category = BL["Consumable"],
            subCategory = BL["Flask"]
        }
    },
    [BL["Scroll"]] = {
        [1] = {
            negate = false,
            operation = "and",
            category = BL["Consumable"],
            subCategory = BL["Scroll"]
        }
    },
    [BL["Bandage"]] = {
        [1] = {
            negate = false,
            operation = "and",
            category = BL["Consumable"],
            subCategory = BL["Bandage"]
        }
    },
    [BL["Metal & Stone"]] = {
        [1] = {
            negate = false,
            operation = "and",
            category = BL["Trade Goods"],
            subCategory = BL["Metal & Stone"]
        }
    },
    [BL["Jewelcrafting"]] = {
        [1] = {
            negate = false,
            operation = "or",
            category = BL["Trade Goods"],
            subCategory = BL["Jewelcrafting"]
        },
        [2] = {
            negate = false,
            operation = "or",
            category = BL["Gem"]
        }
    },
    [BL["Enchanting"]] = {
        [1] = {
            negate = false,
            operation = "and",
            category = BL["Trade Goods"],
            subCategory = BL["Enchanting"]
        }
    },
    [BL["Cloth"]] = {
        [1] = {
            negate = false,
            operation = "and",
            category = BL["Trade Goods"],
            subCategory = BL["Cloth"]
        }
    },
    [BL["Parts"]] = {
        [1] = {
            negate = false,
            operation = "and",
            category = BL["Trade Goods"],
            subCategory = BL["Parts"]
        }
    },
    [BL["Elemental"]] = {
        [1] = {
            negate = false,
            operation = "and",
            category = BL["Trade Goods"],
            subCategory = BL["Elemental"]
        }
    },
    [BL["Trade Goods"]] = {
        [1] = {
            negate = false,
            operation = "and",
            category = BL["Trade Goods"]
        }
    },
    [BL["Quest"]] = {
        [1] = {
            negate = false,
            operation = "and",
            category = BL["Quest"],
            subCategory = BL["Quest"]
        }
    },
    [BL["Reagent"]] = {
        [1] = {
            negate = false,
            operation = "and",
            category = BL["Miscellaneous"],
            subCategory = BL["Reagent"]
        }
    },
    [BL["Devices"]] = {
        [1] = {
            negate = false,
            operation = "and",
            category = BL["Trade Goods"],
            subCategory = BL["Devices"]
        }
    },
    [BL["Junk"]] = {
        [1] = {
            negate = false,
            operation = "and",
            category = "Quality", -- FIXME: localize
            subCategory = ITEM_QUALITY0_DESC
        }
    }
}

Sackville.Options.bagConfig = {
    [1] = {
        name = "Equipment",
        bagType = "player",
        priority = 2,
        sortCriteria = { 
            [1] = {
                key = "level",
                comparison = ">"
            },
            [2] = {
                key = "quality",
                comparison = ">"
            },
            [3] = {
                key = "name",
                comparison = "<"
            }        
        },
        sections = {
            [1] = {
                name = BL["Armor"],
                priority = 1,
                categories = { 
                    BL["Armor"]
                }
            },
            [2] = {
                name = BL["Weapon"],
                categories = { 
                    BL["Weapon"]
                }
            },
            [3] = {
                name = BL["Trinket"],
                categories = { 
                    BL["Trinket"]
                }
            },
            [4] = {
                name = "Jewelry",
                categories = { 
                    "Jewelry"
                }
            },
            [5] = {
                name = BL["Tabard"],
                categories = { 
                    BL["Tabard"]
                }
            }
        }
    },
    [2] = {
        name = BL["Consumable"],
        bagType = "player",
        priority = 2,
        sortCriteria = { 
            [1] = {
                key = "minLevel",
                comparison = ">"
            },
            [2] = {
                key = "name",
                comparison = "<"
            },
            [3] = {
                key = "count",
                comparison = ">"
            }        
        },
        sections = {
            [1] = {
                name = BL["Food & Drink"],
                categories = { 
                    BL["Food & Drink"]
                }
            },
            [2] = {
                name = BL["Flask"],
                categories = { 
                    BL["Flask"]
                }
            },
            [3] = {
                name = BL["Potion"],
                categories = { 
                    BL["Potion"]
                }
            },
            [4] = {
                name = BL["Elixir"],
                categories = { 
                    BL["Elixir"]
                }
            },
            [5] = {
                name = BL["Scroll"],
                categories = { 
                    BL["Scroll"]
                }
            },
            [6] = {
                name = BL["Bandage"],
                categories = { 
                    BL["Bandage"]
                }
            },
            [7] = {
                name = BL["Other"],
                priority = 1,
                categories = { 
                    BL["Consumable"]
                }
            },              
        }
    },
    [3] = {
        name = BL["Trade Goods"],
        bagType = "player",
        priority = 2,
        sortCriteria = { 
            [1] = {
                key = "name",
                comparison = "<"
            },
            [2] = {
                key = "count",
                comparison = ">"
            }        
        },
        sections = {
            [1] = {
                name = BL["Metal & Stone"],
                categories = { 
                    BL["Metal & Stone"]
                }
            },
            [2] = {
                name = BL["Jewelcrafting"],
                categories = {
                    BL["Jewelcrafting"]
                }
            },
            [3] = {
                name = BL["Enchanting"],
                categories = { 
                    BL["Enchanting"]
                }
            },
            [4] = {
                name = BL["Cloth"],
                categories = { 
                    BL["Cloth"]
                }
            },
            [5] = {
                name = BL["Parts"],
                categories = { 
                    BL["Parts"]
                }
            },
            [6] = {
                name = BL["Elemental"],
                categories = { 
                    BL["Elemental"]
                }
            },
            [7] = {
                name = BL["Other"],
                priority = 1,
                categories = { 
                    BL["Elemental"]
                }
            }         
        }
    },
    [4] = {
        name = BL["Other"],
        bagType = "player",
        priority = 1,
        sortCriteria = { 
            [1] = {
                key = "name",
                comparison = "<"
            },
            [2] = {
                key = "count",
                comparison = ">"
            }        
        },
        sections = {
            [1] = {
                name = BL["Quest"],
                categories = { 
                    BL["Quest"]
                }
            },
            [2] = {
                name = BL["Reagent"],
                categories = { 
                    BL["Reagent"]
                }
            },
            [3] = {
                name = BL["Devices"],
                categories = { 
                    BL["Devices"]
                }
            },
            [4] = {
                name = BL["Junk"],
                categories = { 
                    BL["Junk"]
                }
            },
            [5] = {
                name = BL["Other"],
                priority = 0,
                showEmptySlot = true,
                defaultSection = true
            }
        }
    },
    [5] = {
        name = "Bank Equipment",
        bagType = "bank",
        priority = 2,
        sortCriteria = { 
            [1] = {
                key = "level",
                comparison = ">"
            },
            [2] = {
                key = "quality",
                comparison = ">"
            },
            [3] = {
                key = "name",
                comparison = "<"
            }        
        },
        sections = {
            [1] = {
                name = BL["Armor"],
                priority = 1,
                categories = { 
                    BL["Armor"]
                }
            },
            [2] = {
                name = BL["Weapon"],
                categories = { 
                    BL["Weapon"]
                }
            },
            [3] = {
                name = BL["Trinket"],
                categories = { 
                    BL["Trinket"]
                }
            },
            [4] = {
                name = "Jewelry",
                categories = { 
                    "Jewelry"
                }
            },
            [5] = {
                name = BL["Tabard"],
                categories = { 
                    BL["Tabard"]
                }
            }
        }
    },
    [6] = {
        name = "Bank Consumable",
        bagType = "bank",
        priority = 2,
        sortCriteria = { 
            [1] = {
                key = "minLevel",
                comparison = ">"
            },
            [2] = {
                key = "name",
                comparison = "<"
            },
            [3] = {
                key = "count",
                comparison = ">"
            }        
        },
        sections = {
            [1] = {
                name = BL["Food & Drink"],
                categories = { 
                    BL["Food & Drink"]
                }
            },
            [2] = {
                name = BL["Flask"],
                categories = { 
                    BL["Flask"]
                }
            },
            [3] = {
                name = BL["Potion"],
                categories = { 
                    BL["Potion"]
                }
            },
            [4] = {
                name = BL["Elixir"],
                categories = { 
                    BL["Elixir"]
                }
            },
            [5] = {
                name = BL["Scroll"],
                categories = { 
                    BL["Scroll"]
                }
            },
            [6] = {
                name = BL["Bandage"],
                categories = { 
                    BL["Bandage"]
                }
            },
            [7] = {
                name = BL["Other"],
                priority = 1,
                categories = { 
                    BL["Consumable"]
                }
            },              
        }
    },
    [7] = {
        name = "Bank Trade Goods",
        bagType = "bank",
        priority = 2,
        sortCriteria = { 
            [1] = {
                key = "name",
                comparison = "<"
            },
            [2] = {
                key = "count",
                comparison = ">"
            }        
        },
        sections = {
            [1] = {
                name = BL["Metal & Stone"],
                categories = { 
                    BL["Metal & Stone"]
                }
            },
            [2] = {
                name = BL["Jewelcrafting"],
                categories = {
                    BL["Jewelcrafting"]
                }
            },
            [3] = {
                name = BL["Enchanting"],
                categories = { 
                    BL["Enchanting"]
                }
            },
            [4] = {
                name = BL["Cloth"],
                categories = { 
                    BL["Cloth"]
                }
            },
            [5] = {
                name = BL["Parts"],
                categories = { 
                    BL["Parts"]
                }
            },
            [6] = {
                name = BL["Elemental"],
                categories = { 
                    BL["Elemental"]
                }
            },
            [7] = {
                name = BL["Other"],
                priority = 1,
                categories = { 
                    BL["Elemental"]
                }
            }         
        }
    },
    [8] = {
        name = "Bank Other",
        bagType = "bank",
        priority = 1,
        sortCriteria = { 
            [1] = {
                key = "name",
                comparison = "<"
            },
            [2] = {
                key = "count",
                comparison = ">"
            }        
        },
        sections = {
            [1] = {
                name = BL["Quest"],
                categories = { 
                    BL["Quest"]
                }
            },
            [2] = {
                name = BL["Reagent"],
                categories = { 
                    BL["Reagent"]
                }
            },
            [3] = {
                name = BL["Devices"],
                categories = { 
                    BL["Devices"]
                }
            },
            [4] = {
                name = BL["Junk"],
                categories = { 
                    BL["Junk"]
                }
            },
            [5] = {
                name = BL["Other"],
                priority = 0,
                showEmptySlot = true,
                defaultSection = true
            }
        }
    }

}

-- These are "standard" because they match up with the Type and SubType
-- values returned by GetItemInfo()
Sackville.Options.standardCategories = {
    [BL["Armor"]] = {
        BL["Miscellaneous"],
        BL["Cloth"],
        BL["Leather"],
        BL["Mail"],
        BL["Plate"],
        BL["Shields"],
        BL["Librams"],
        BL["Idols"],
        BL["Totems"],
        BL["Sigils"]
    },
    [BL["Consumable"]] = {
        BL["Food & Drink"],
        BL["Potion"],
        BL["Elixir"],
        BL["Flask"],
        BL["Bandage"],
        BL["Item Enhancement"],
        BL["Scroll"],
        BL["Other"]
    },
    [BL["Container"]] = {
        BL["Bag"],
        BL["Enchanting Bag"],
        BL["Engineering Bag"],
        BL["Gem Bag"],
        BL["Herb Bag"],
        BL["Mining Bag"],
        BL["Soul Bag"],
        BL["Leatherworking Bag"]
    },
    [BL["Gem"]] = {
        BL["Blue"],
        BL["Green"],
        BL["Orange"],
        BL["Meta"],
        BL["Prismatic"],
        BL["Purple"],
        BL["Red"],
        BL["Simple"],
        BL["Yellow"]
    },
    [BL["Miscellaneous"]] = {
        BL["Junk"],
        BL["Reagent"],
        BL["Pet"],
        BL["Holiday"],
        BL["Mount"],
        BL["Other"]
    },
    [BL["Recipe"]] = {
        BL["Alchemy"],
        BL["Blacksmithing"],
        BL["Book"],
        BL["Cooking"],
        BL["Enchanting"],
        BL["Engineering"],
        BL["First Aid"],
        BL["Leatherworking"],
        BL["Tailoring"]
    },
    [BL["Quest"]] = {
        BL["Quest"]
    },
    [BL["Trade Goods"]] = {
        BL["Armor Enchantment"],
        BL["Cloth"],
        BL["Devices"],
        BL["Elemental"],
        BL["Enchanting"],
        BL["Explosives"],
        BL["Herb"],
        BL["Jewelcrafting"],
        BL["Leather"],
        BL["Materials"],
        BL["Meat"],
        BL["Metal & Stone"],
        BL["Other"],
        BL["Parts"],
        BL["Trade Goods"],
        BL["Weapon Enchantment"]
    },
    [BL["Weapon"]] = {
        BL["Bows"],
        BL["Crossbows"],
        BL["Daggers"],
        BL["Guns"],
        BL["Fishing Poles"],
        BL["Fist Weapons"],
        BL["Miscellaneous"],
        BL["One-Handed Axes"],
        BL["One-Handed Maces"],
        BL["One-Handed Swords"],
        BL["Polearms"],
        BL["Staves"],
        BL["Thrown"],
        BL["Two-Handed Axes"],
        BL["Two-Handed Maces"],
        BL["Two-Handed Swords"],
        BL["Wands"]
    }
}

